diff --git a/game/core/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryDyeing.java b/game/core/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryDyeing.java
new file mode 100644
index 000000000..941dd89b3
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryDyeing.java
@@ -0,0 +1,181 @@
+package net.minecraft.core.data.registry.recipe.entry;
+
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.data.registry.Registries;
+import net.minecraft.core.data.registry.recipe.*;
+import net.minecraft.core.data.registry.recipe.adapter.RecipeEntryDyeingJsonAdapter;
+import net.minecraft.core.data.registry.recipe.adapter.RecipeEntryUndyeingJsonAdapter;
+import net.minecraft.core.data.registry.recipe.adapter.RecipeJsonAdapter;
+import net.minecraft.core.item.Item;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.item.Items;
+import net.minecraft.core.player.inventory.container.ContainerCrafting;
+import net.minecraft.core.util.helper.DyeColor;
+
+import java.util.List;
+import java.util.Objects;
+
+public class RecipeEntryDyeing extends RecipeEntryCraftingDynamic implements HasJsonAdapter {
+    public RecipeSymbol inputSymbol;
+    public ItemStack output;
+    public boolean useUpperMeta;
+    public boolean useItemMeta;
+    public RecipeEntryDyeing() {
+
+    }
+
+    public RecipeEntryDyeing(RecipeSymbol input, ItemStack output, boolean useUpperMeta, boolean useItemMeta) {
+        this.inputSymbol = input;
+        this.output = output;
+        this.useUpperMeta = useUpperMeta;
+        this.useItemMeta = useItemMeta;
+    }
+
+    @Override
+    public boolean matches(ContainerCrafting containerCrafting) {
+        boolean hasDye = false;
+        boolean hasItem = false;
+        for (int i = 0; i < 9; i++) {
+            ItemStack stack = containerCrafting.getItem(i);
+            if (stack != null && stack.getItem() == Items.DYE) {
+                if (hasDye) return false;
+                hasDye = true;
+            } else if (stack != null && !inputSymbol.matches(stack)) {
+                return false;
+            } else if (inputSymbol.matches(stack)) {
+                hasItem = true;
+            }
+        }
+        return hasDye && hasItem;
+    }
+
+    @Override
+    public boolean matchesQuery(SearchQuery query) {
+        switch (query.mode){
+            case ALL: {
+                if ((matchesRecipe(query) || matchesUsage(query)) && matchesScope(query)) return true;
+                break;
+            }
+            case RECIPE: {
+                if (matchesRecipe(query) && matchesScope(query)) return true;
+                break;
+            }
+            case USAGE: {
+                if (matchesUsage(query) && matchesScope(query)) return true;
+                break;
+            }
+        }
+        return false;
+    }
+
+    public boolean matchesScope(SearchQuery query){
+        if(query.scope.getLeft() == SearchQuery.SearchScope.NONE) return true;
+        if(query.scope.getLeft() == SearchQuery.SearchScope.NAMESPACE) {
+            RecipeNamespace namespace = Registries.RECIPES.getItem(query.scope.getRight());
+            if(namespace == parent.getParent()){
+                return true;
+            }
+        } else if (query.scope.getLeft() == SearchQuery.SearchScope.NAMESPACE_GROUP) {
+            RecipeGroup group;
+            try {
+                group = Registries.RECIPES.getGroupFromKey(query.scope.getRight());
+            } catch (IllegalArgumentException e){
+                group = null;
+            }
+            if(group == parent){
+                return true;
+            }
+        }
+        return false;
+    }
+
+    public boolean matchesRecipe(SearchQuery query) {
+        if(query.query.getLeft() == SearchQuery.QueryType.NAME) {
+            for (int i = 0; i < DyeColor.COLOR_AMOUNT; i++) {
+                ItemStack output = new ItemStack(this.output.itemID, this.output.stackSize, getOutputMetaFromInputMeta(i));
+                if(query.strict && output.getDisplayName().equalsIgnoreCase(query.query.getRight())){
+                    return true;
+                } else if(!query.strict && output.getDisplayName().toLowerCase().contains(query.query.getRight().toLowerCase())){
+                    return true;
+                }
+            }
+        } else if (query.query.getLeft() == SearchQuery.QueryType.GROUP && !Objects.equals(query.query.getRight(), "")) {
+            List<ItemStack> groupStacks = new RecipeSymbol(query.query.getRight()).resolve();
+            if(groupStacks == null) return false;
+            return groupStacks.contains(output);
+        }
+        return false;
+    }
+
+    public boolean matchesUsage(SearchQuery query) {
+        RecipeSymbol[] symbols = {inputSymbol, new RecipeSymbol(Blocks.SPONGE_WET.getDefaultStack())};
+        for (RecipeSymbol symbol : symbols) {
+            if(symbol == null) continue;
+            List<ItemStack> stacks = symbol.resolve();
+            if(query.query.getLeft() == SearchQuery.QueryType.NAME) {
+                for (ItemStack stack : stacks) {
+                    if(query.strict && stack.getDisplayName().equalsIgnoreCase(query.query.getRight())){
+                        return true;
+                    } else if (!query.strict && stack.getDisplayName().toLowerCase().contains(query.query.getRight().toLowerCase())) {
+                        return true;
+                    }
+                }
+            } else if (query.query.getLeft() == SearchQuery.QueryType.GROUP && !Objects.equals(query.query.getRight(), "")) {
+                List<ItemStack> groupStacks = new RecipeSymbol(query.query.getRight()).resolve();
+                if(groupStacks == null) return false;
+                if(stacks.stream().anyMatch((groupStacks::contains))){
+                    return true;
+                }
+            }
+
+        }
+        return false;
+    }
+
+    @Override
+    public ItemStack getCraftingResult(ContainerCrafting containerCrafting) {
+        int dyeMeta = 0;
+        int items = 0;
+        for (int i = 0; i < containerCrafting.getContainerSize(); i++) {
+            ItemStack itemstack1 = containerCrafting.getItem(i);
+            if (itemstack1 == null){
+                continue;
+            }
+            if (itemstack1.getItem() == Items.DYE){
+                dyeMeta = itemstack1.getMetadata();
+                continue;
+            }
+            items++;
+        }
+
+        return new ItemStack(output.getItem(), items, getOutputMetaFromInputMeta(dyeMeta));
+    }
+
+    public int getOutputMetaFromInputMeta(int meta) {
+        DyeColor dyeColor = DyeColor.colorFromItemMeta(meta);
+        if(useItemMeta){
+            return useUpperMeta ? dyeColor.itemMeta << 4 : dyeColor.itemMeta;
+        } else {
+            return useUpperMeta ? dyeColor.blockMeta << 4 : dyeColor.blockMeta;
+        }
+    }
+
+    @Override
+    public int getRecipeSize() {
+        return 2;
+    }
+
+    @Override
+    public ItemStack[] onCraftResult(ContainerCrafting containerCrafting) {
+        ItemStack[] returnStack = new ItemStack[9];
+        for (int i = 0; i < containerCrafting.getContainerSize(); i++) {
+            containerCrafting.removeItem(i, 1);
+        }
+        return returnStack;
+    }
+
+    @Override
+    public RecipeJsonAdapter<?> getAdapter() {
+        return new RecipeEntryDyeingJsonAdapter();
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/data/tag/Tag.java b/game/core/src/main/java/net/minecraft/core/data/tag/Tag.java
index 43dc5b087..e165d01a3 100644
--- a/game/core/src/main/java/net/minecraft/core/data/tag/Tag.java
+++ b/game/core/src/main/java/net/minecraft/core/data/tag/Tag.java
@@ -87,7 +87,7 @@ public class Tag<E extends ITaggable<E>>
     }
 
     /**
-     * Determines if the tag applies to the given element, i.e. <tt>element</tt> is in {@link Tag#elements}.
+     * Determines if the tag applies to the given element, i.e. {@code element} is in {@link Tag#elements}.
      */
     public boolean appliesTo(E element) 
     {
diff --git a/game/core/src/main/java/net/minecraft/core/entity/Entity.java b/game/core/src/main/java/net/minecraft/core/entity/Entity.java
index 047631c48..53b096042 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/Entity.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/Entity.java
@@ -73,7 +73,8 @@ public abstract class Entity
     public boolean collision = false;
     public boolean hurtMarked = false;
     public boolean hadNicknameSet;
-    public boolean stuck;
+    public boolean stuckInCobweb;
+    public boolean stuckInSpikes;
     public boolean slide = true;
     public boolean removed = false;
     public float heightOffset = 0.0F;
@@ -431,15 +432,32 @@ public abstract class Entity
         ySlideOffset *= 0.4f;
         double d3 = this.x;
         double d4 = this.z;
-        if(stuck)
+        if(stuckInCobweb)
         {
-            stuck = false;
+            // Restricts all movement
             xd *= 0.25;
-            yd *= 0.05;
-            zd *= 0.25;
             this.xd = 0.0;
+            zd *= 0.25;
+            this.zd = 0.0;
+            yd *= 0.05;
+
+            // Cancels the player's jump
             this.yd = 0.0;
+
+            stuckInCobweb = false;
+        }
+        if(stuckInSpikes)
+        {
+            // Restricts all horizontal movement
+            xd *= 0.25;
+            this.xd = 0.0;
+            zd *= 0.25;
             this.zd = 0.0;
+
+            // Cancels the player's jump
+            this.yd = 0.0;
+
+            stuckInSpikes = false;
         }
         double oldXd = xd;
         double oldYd = yd;
diff --git a/game/core/src/main/java/net/minecraft/core/entity/Mob.java b/game/core/src/main/java/net/minecraft/core/entity/Mob.java
index 21e66a545..ed375d1ba 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/Mob.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/Mob.java
@@ -235,6 +235,8 @@ public abstract class Mob extends Entity
         {
             if(item.hasCustomColor()) {
             	this.chatColor = item.getCustomColor();
+            } else {
+                this.chatColor = 0;
             }
             setNickname(StringUtils.substring(item.getCustomName(), 0, 32));
             return false;
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemLabel.java b/game/core/src/main/java/net/minecraft/core/item/ItemLabel.java
index b15a9b6db..4dea72b1b 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemLabel.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemLabel.java
@@ -50,7 +50,10 @@ public class ItemLabel extends Item
 		AABB box = AABB.getTemporaryBB(blockX, blockY, blockZ, blockX + 1, blockY + 1, blockZ + 1);
 		List<Entity> entities = world.getEntitiesWithinAABBExcludingEntity(null, box);
         for (Entity entity : entities) {
-            if (entity instanceof Mob && !entity.hadNicknameSet) {
+            if (!(entity instanceof Player) && entity instanceof Mob && !entity.hadNicknameSet) {
+				if (itemStack.hasCustomColor()) {
+					((Mob) entity).chatColor = itemStack.getCustomColor();
+				}
                 ((Mob) entity).setNickname(StringUtils.substring(itemStack.getCustomName(), 0, 32));
 				break;
             }
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemStack.java b/game/core/src/main/java/net/minecraft/core/item/ItemStack.java
index 0d59e5f00..63237381b 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemStack.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemStack.java
@@ -29,57 +29,57 @@ public final class ItemStack {
     @NotNull
     private CompoundTag tag;
 
-    public ItemStack(IItemConvertible item)
+    public ItemStack(@NotNull IItemConvertible item)
     {
         this(item, 1);
     }
 
-    public ItemStack(IItemConvertible item, int stackSize)
+    public ItemStack(@NotNull IItemConvertible item, int stackSize)
     {
         this(item, stackSize, 0);
     }
 
-    public ItemStack(IItemConvertible item, int stackSize, int metadata)
+    public ItemStack(@NotNull IItemConvertible item, int stackSize, int metadata)
     {
         this(item.asItem(), stackSize, metadata);
     }
 
-    public ItemStack(Block<?> block)
+    public ItemStack(@NotNull Block<?> block)
     {
         this(block, 1);
     }
 
-    public ItemStack(Block<?> block, int stackSize)
+    public ItemStack(@NotNull Block<?> block, int stackSize)
     {
         this(block.id(), stackSize, 0);
     }
 
-    public ItemStack(Block<?> block, int stackSize, int metadata)
+    public ItemStack(@NotNull Block<?> block, int stackSize, int metadata)
     {
         this(block.id(), stackSize, metadata);
     }
 
-    public ItemStack(Block<?> block, int stackSize, int metadata, @Nullable CompoundTag tag)
+    public ItemStack(@NotNull Block<?> block, int stackSize, int metadata, @Nullable CompoundTag tag)
     {
         this(block.id(), stackSize, metadata, tag);
     }
 
-    public ItemStack(Item item)
+    public ItemStack(@NotNull Item item)
     {
         this(item.id, 1, 0);
     }
 
-    public ItemStack(Item item, int stackSize)
+    public ItemStack(@NotNull Item item, int stackSize)
     {
         this(item.id, stackSize, 0);
     }
 
-    public ItemStack(Item item, int stackSize, int metadata)
+    public ItemStack(@NotNull Item item, int stackSize, int metadata)
     {
         this(item.id, stackSize, metadata);
     }
 
-    public ItemStack(Item item, int stackSize, int metadata, @Nullable CompoundTag tag)
+    public ItemStack(@NotNull Item item, int stackSize, int metadata, @Nullable CompoundTag tag)
     {
         this(item.id, stackSize, metadata, tag);
     }
@@ -89,7 +89,7 @@ public final class ItemStack {
         this(itemID, stackSize, metadata, Item.itemsList[itemID].getDefaultTag());
     }
     
-    public ItemStack(ItemStack itemStack) {
+    public ItemStack(@NotNull ItemStack itemStack) {
         this.itemID = itemStack.itemID;
         this.metadata = itemStack.metadata;
         this.stackSize = itemStack.stackSize;
@@ -111,7 +111,7 @@ public final class ItemStack {
         tag = new CompoundTag();
     }
 
-    public ItemStack splitStack(int i)
+    public @NotNull ItemStack splitStack(int i)
     {
         ItemStack itemStack = new ItemStack(this);
         itemStack.stackSize = i;
@@ -124,7 +124,7 @@ public final class ItemStack {
         return Objects.requireNonNull(Item.itemsList[itemID]);
     }
 
-    public boolean useItem(Player entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced)
+    public boolean useItem(@NotNull Player entityplayer, @NotNull World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced)
     {
         boolean flag = getItem().onUseItemOnBlock(this, entityplayer, world, blockX, blockY, blockZ, side, xPlaced, yPlaced);
         if(flag)
@@ -134,17 +134,17 @@ public final class ItemStack {
         return flag;
     }
 
-    public float getStrVsBlock(Block<?> block)
+    public float getStrVsBlock(@NotNull Block<?> block)
     {
         return getItem().getStrVsBlock(this, block);
     }
 
-    public ItemStack useItemRightClick(World world, Player entityplayer)
+    public ItemStack useItemRightClick(@NotNull World world, @NotNull Player entityplayer)
     {
         return getItem().onUseItem(this, world, entityplayer);
     }
 
-	public CompoundTag writeToNBT(CompoundTag nbt) {
+	public @NotNull CompoundTag writeToNBT(@NotNull CompoundTag nbt) {
 		nbt.putShort("id", (short) itemID);
 		nbt.putByte("Count", (byte) stackSize);
 		nbt.putShort("Damage", (short) metadata);
@@ -156,7 +156,7 @@ public final class ItemStack {
 		return nbt;
 	}
 
-	public void readFromNBT(CompoundTag nbt) {
+	public void readFromNBT(@NotNull CompoundTag nbt) {
 		itemID = nbt.getShort("id");
 		stackSize = nbt.getByte("Count");
 		metadata = nbt.getShort("Damage");
@@ -342,27 +342,27 @@ public final class ItemStack {
         return Item.itemsList[itemID].useItemOnEntity(this, mob, entityPlayer);
     }
 
-    public ItemStack copy()
+    public @NotNull ItemStack copy()
     {
         return new ItemStack(itemID, stackSize, metadata, new CompoundTag(tag));
     }
 
-    public static boolean areItemStacksEqual(ItemStack itemstack, ItemStack itemstack1)
+    public static boolean areItemStacksEqual(@Nullable ItemStack stack1, @Nullable ItemStack stack2)
     {
-        if(itemstack == null && itemstack1 == null)
+        if(stack1 == null && stack2 == null)
         {
             return true;
         }
-        if(itemstack == null || itemstack1 == null)
+        if(stack1 == null || stack2 == null)
         {
             return false;
         } else
         {
-            return itemstack.isItemStackEqual(itemstack1);
+            return stack1.isItemStackEqual(stack2);
         }
     }
 
-    private boolean isItemStackEqual(ItemStack itemstack)
+    private boolean isItemStackEqual(@NotNull ItemStack itemstack)
     {
         if(stackSize != itemstack.stackSize)
         {
@@ -375,7 +375,7 @@ public final class ItemStack {
         return metadata == itemstack.metadata;
     }
 
-    public boolean isItemEqual(ItemStack itemstack)
+    public boolean isItemEqual(@NotNull ItemStack itemstack)
     {
         return itemID == itemstack.itemID && metadata == itemstack.metadata;
     }
@@ -388,7 +388,7 @@ public final class ItemStack {
         return Item.itemsList[itemID].getTranslatedDescription(this);
     }
 
-    public static ItemStack copyItemStack(ItemStack itemstack)
+    public static ItemStack copyItemStack(@Nullable ItemStack itemstack)
     {
         return itemstack != null ? itemstack.copy() : null;
     }
@@ -399,7 +399,7 @@ public final class ItemStack {
         return stackSize + " * " + Item.itemsList[itemID].getKey() + ":" + metadata;
     }
 
-    public void updateAnimation(World world, Entity entity, int slotId, boolean flag)
+    public void updateAnimation(@NotNull World world, Entity entity, int slotId, boolean flag)
     {
         if(animationsToGo > 0)
         {
@@ -408,18 +408,18 @@ public final class ItemStack {
         Item.itemsList[itemID].inventoryTick(this, world, entity, slotId, flag);
     }
 
-    public void onCrafting(World world, Player entityplayer)
+    public void onCrafting(@NotNull World world, @NotNull Player entityplayer)
     {
         entityplayer.addStat(getItem().getStat(StatList.STAT_CRAFTED), stackSize);
         Item.itemsList[itemID].onCraftedBy(this, world, entityplayer);
     }
 
-    public boolean isStackEqual(ItemStack itemstack)
+    public boolean isStackEqual(@NotNull ItemStack itemstack)
     {
         return itemID == itemstack.itemID && stackSize == itemstack.stackSize && metadata == itemstack.metadata;
     }
     
-    public boolean canStackWith(ItemStack itemStack) {
+    public boolean canStackWith(@Nullable ItemStack itemStack) {
         if(itemStack == null) return true;
         if(this.itemID != itemStack.itemID || this.metadata != itemStack.metadata) {
         	return false;
@@ -435,7 +435,7 @@ public final class ItemStack {
         return getMaxStackSize() == 1 && isItemStackDamageable();
     }
     
-    public static ItemStack readItemStackFromNbt(CompoundTag nbt) {
+    public static ItemStack readItemStackFromNbt(@Nullable CompoundTag nbt) {
         if(nbt == null) {
             return null;
         }
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemWandSpawner.java b/game/core/src/main/java/net/minecraft/core/item/ItemWandSpawner.java
index 0468892fe..fb1e30cdd 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemWandSpawner.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemWandSpawner.java
@@ -55,6 +55,9 @@ public class ItemWandSpawner extends Item implements IDispensable
             entity.setPos(x, y, z);
             entity.spawnInit();
             if (itemStack.hasCustomName() && entity instanceof Mob){
+                if (itemStack.hasCustomColor()) {
+                    ((Mob) entity).chatColor = itemStack.getCustomColor();
+                }
                 ((Mob)entity).setNickname(itemStack.getCustomName());
             }
             world.entityJoinedWorld(entity);
diff --git a/game/core/src/main/java/net/minecraft/core/lang/LanguageSeeker.java b/game/core/src/main/java/net/minecraft/core/lang/LanguageSeeker.java
index f6f6f52df..7dce01afa 100644
--- a/game/core/src/main/java/net/minecraft/core/lang/LanguageSeeker.java
+++ b/game/core/src/main/java/net/minecraft/core/lang/LanguageSeeker.java
@@ -27,10 +27,10 @@ public class LanguageSeeker {
      */
     public static final File LANGUAGE_DIR = Global.accessor.getMinecraftDir().toPath().resolve("languages").toFile();
     /**
-     * Finds a language with a specific ID. If nothing is found, <tt>null</tt> is returned.
+     * Finds a language with a specific ID. If nothing is found, {@code null} is returned.
      *
      * @param id the ID of the language to find
-     * @return the language found, or <tt>null</tt> if no language with the specific ID is found
+     * @return the language found, or {@code null} if no language with the specific ID is found
      * @throws IOException if an I/O error has occured
      */
     @Nullable
@@ -99,7 +99,7 @@ public class LanguageSeeker {
     }
 
     /**
-     * Get all the languages available in the <tt>languages</tt> folder.
+     * Get all the languages available in the {@code null} folder.
      *
      * @return all the available languages as a list
      * @throws IOException if an I/O error has occured
diff --git a/game/core/src/main/java/net/minecraft/core/net/handler/PacketHandler.java b/game/core/src/main/java/net/minecraft/core/net/handler/PacketHandler.java
index 32eba03f5..95cde2c70 100644
--- a/game/core/src/main/java/net/minecraft/core/net/handler/PacketHandler.java
+++ b/game/core/src/main/java/net/minecraft/core/net/handler/PacketHandler.java
@@ -82,7 +82,7 @@ public abstract class PacketHandler
         handleInvalidPacket(packetEntityFling);
     }
 
-    public void handlePlace(PacketUseItem useItemPacket)
+    public void handlePlace(PacketUseOrPlaceItemStack useItemPacket)
     {
         handleInvalidPacket(useItemPacket);
     }
diff --git a/game/core/src/main/java/net/minecraft/core/net/packet/Packet.java b/game/core/src/main/java/net/minecraft/core/net/packet/Packet.java
index ebb157a66..d2f511dd4 100644
--- a/game/core/src/main/java/net/minecraft/core/net/packet/Packet.java
+++ b/game/core/src/main/java/net/minecraft/core/net/packet/Packet.java
@@ -270,7 +270,7 @@ public abstract class Packet
         addMapping(12, true, true, PacketMovePlayer.Rot.class);
         addMapping(13, true, true, PacketMovePlayer.PosRot.class);
         addMapping(14, false, true, PacketPlayerAction.class);
-        addMapping(15, false, true, PacketUseItem.class);
+        addMapping(15, false, true, PacketUseOrPlaceItemStack.class);
         addMapping(16, true, true, PacketSetCarriedItem.class);
         addMapping(17, true, false, PacketSleep.class);
         addMapping(18, true, true, PacketAnimate.class);
diff --git a/game/core/src/main/java/net/minecraft/core/net/packet/PacketUseItem.java b/game/core/src/main/java/net/minecraft/core/net/packet/PacketUseOrPlaceItemStack.java
similarity index 62%
rename from game/core/src/main/java/net/minecraft/core/net/packet/PacketUseItem.java
rename to game/core/src/main/java/net/minecraft/core/net/packet/PacketUseOrPlaceItemStack.java
index 374b39e0b..8f1f04fe5 100644
--- a/game/core/src/main/java/net/minecraft/core/net/packet/PacketUseItem.java
+++ b/game/core/src/main/java/net/minecraft/core/net/packet/PacketUseOrPlaceItemStack.java
@@ -4,15 +4,51 @@ import java.io.DataInputStream;
 import java.io.DataOutputStream;
 import java.io.IOException;
 
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.net.handler.PacketHandler;
 import net.minecraft.core.util.helper.Direction;
+import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.world.World;
 
-public class PacketUseItem extends Packet
+public class PacketUseOrPlaceItemStack extends Packet
 {
-    public static final byte TYPE_USE_ITEM_ON = 0;
-    public static final byte TYPE_USE_ITEM = 1;
-    public static final byte TYPE_USE_STACK_ON = 2;
+    public static final byte TYPE_USE_OR_PLACE_ON_TILE = 0;
+    public static final byte TYPE_USE_ON_NOTHING = 1;
+    public static final byte TYPE_PLACE_ONLY = 2;
+
+    /**
+     * Deprecated in 7.3_03
+     * <p>
+     * Equals {@link PacketUseOrPlaceItemStack#TYPE_USE_OR_PLACE_ON_TILE}
+     * <p>
+     * Can be removed at any time.
+     */
+    @Deprecated
+    public static final byte TYPE_USE_ITEM_ON =
+        TYPE_USE_OR_PLACE_ON_TILE;
+
+    /**
+     * Deprecated in 7.3_03
+     * <p>
+     * Equals {@link PacketUseOrPlaceItemStack#TYPE_USE_ON_NOTHING}
+     * <p>
+     * Can be removed at any time.
+     */
+    @Deprecated
+    public static final byte TYPE_USE_ITEM =
+        TYPE_USE_ON_NOTHING;
+
+    /**
+     * Deprecated in 7.3_03
+     * <p>
+     * Equals {@link PacketUseOrPlaceItemStack#TYPE_PLACE_ONLY}
+     * <p>
+     * Can be removed at any time.
+     */
+    @Deprecated
+    public static final byte TYPE_USE_STACK_ON =
+        TYPE_PLACE_ONLY;
 
     public int xPosition;
     public int yPosition;
@@ -23,11 +59,11 @@ public class PacketUseItem extends Packet
     public ItemStack itemStack;
     public byte type;
 
-    public PacketUseItem()
+    public PacketUseOrPlaceItemStack()
     {
     }
 
-    public PacketUseItem(int x, int y, int z, Direction direction, ItemStack itemstack, double xPlaced, double yPlaced, byte type)
+    public PacketUseOrPlaceItemStack(int x, int y, int z, Direction direction, ItemStack itemstack, double xPlaced, double yPlaced, byte type)
     {
         xPosition = x;
         yPosition = y;
diff --git a/game/core/src/main/java/net/minecraft/core/world/pathfinder/PathFinder.java b/game/core/src/main/java/net/minecraft/core/world/pathfinder/PathFinder.java
index c889e23fb..fdc7611ee 100644
--- a/game/core/src/main/java/net/minecraft/core/world/pathfinder/PathFinder.java
+++ b/game/core/src/main/java/net/minecraft/core/world/pathfinder/PathFinder.java
@@ -6,9 +6,12 @@ import it.unimi.dsi.fastutil.ints.Int2ObjectMap;
 import it.unimi.dsi.fastutil.ints.Int2ObjectOpenHashMap;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogicDoor;
+import net.minecraft.core.block.BlockLogicTrapDoor;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.block.material.Material;
+import net.minecraft.core.entity.Mob;
+import net.minecraft.core.entity.monster.MobCreeper;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.WorldSource;
 import org.jetbrains.annotations.Nullable;
@@ -190,21 +193,31 @@ public class PathFinder
             {
                 for(int z1 = z; z1 < z + pathpoint.z; z1++)
                 {
-                    int k1 = worldSource.getBlockId(x1, y1, z1);
-                    if(k1 <= 0)
+                    int blockId = worldSource.getBlockId(x1, y1, z1);
+                    if(blockId <= 0)
                     {
                         continue;
                     }
-                    if(Block.hasLogicClass(Blocks.blocksList[k1], BlockLogicDoor.class))
+                    if(Block.hasLogicClass(Blocks.blocksList[blockId], BlockLogicDoor.class))
                     {
-                        int l1 = worldSource.getBlockMetadata(x1, y1, z1);
-                        if(!BlockLogicDoor.isOpen(l1))
+                        int blockMetadata = worldSource.getBlockMetadata(x1, y1, z1);
+                        if(!BlockLogicDoor.isOpen(blockMetadata))
                         {
                             return 0;
                         }
                         continue;
                     }
-                    Material material = Blocks.blocksList[k1].getMaterial();
+                    //Check to allow creepers to pathfind underneath top-closed trapdoors
+                    if(entity instanceof MobCreeper){
+                        int blockMetadata = worldSource.getBlockMetadata(x1, y1, z1);
+                        if(Block.hasLogicClass(Blocks.blocksList[blockId], BlockLogicTrapDoor.class)){
+                            boolean isTopClosedTrapdoor = !BlockLogicTrapDoor.isTrapdoorOpen(blockMetadata) && BlockLogicTrapDoor.isUpperHalf(blockMetadata);
+                            if(isTopClosedTrapdoor){
+                                return 1;
+                            }
+                        }
+                    }
+                    Material material = Blocks.blocksList[blockId].getMaterial();
                     if(material.blocksMotion())
                     {
                         return 0;
diff --git a/game/core/src/main/resources/lang/en_US/gui.lang b/game/core/src/main/resources/lang/en_US/gui.lang
index a6e2b5d42..db6c86912 100644
--- a/game/core/src/main/resources/lang/en_US/gui.lang
+++ b/game/core/src/main/resources/lang/en_US/gui.lang
@@ -16,7 +16,7 @@ gui.achievements.page.overworld.desc=Achievements of the starting dimension!
 gui.achievements.page.nether.name=Nether
 gui.achievements.page.nether.desc=Achievements from Hell!
 
-gui.add_server.label.title=Add server
+gui.add_server.label.title=Add Server
 gui.add_server.button.save=Save
 gui.add_server.button.cancel=Cancel
 gui.add_server.button.show_ip=Show IP: %s
diff --git a/game/core/src/main/resources/lang/en_US/options.lang b/game/core/src/main/resources/lang/en_US/options.lang
index a5a5e8698..953aaf240 100644
--- a/game/core/src/main/resources/lang/en_US/options.lang
+++ b/game/core/src/main/resources/lang/en_US/options.lang
@@ -150,7 +150,10 @@ options.colorblindnessFix.protanopia=Protanopia
 options.colorblindnessFix.deuteranopia=Deuteranopia
 options.colorblindnessFix.tritanopia=Tritanopia
 options.colorblindnessFix.grayscale=Grayscale
-options.alwaysShowDescriptions=Always Show Item Descriptions
+options.itemDescriptions=Item Description
+options.itemDescriptions.never_prompt=Never Prompt
+options.itemDescriptions.prompt=Prompt
+options.itemDescriptions.always_show=Always Show
 options.flightSpeed=Flight Speed
 options.flightSmoothness=Flight Smoothness
 options.customAnimations=Custom Animations
